<?php

namespace EventPortal\Domain\Event\ViewModels;

use EventPortal\Concerns\Respondable;
use EventPortal\Domain\Component\Actions;
use EventPortal\Domain\Field\Models\Field;
use EventPortal\Domain\Field\Resources\FieldCollection;
use Spatie\ViewModels\ViewModel;

class EventCreateViewModel extends ViewModel
{
    /**
     * @var Respondable
     */
    public $model;

    /**
     * @var Actions
     */
    private $actions;

    public function __construct(Respondable $model, ?Actions $actions)
    {
        $this->model = $model;
        $this->actions = optional($actions)->toArray();
    }

    public function form(): FieldCollection
    {
        $fields = Field::forModel($this->model)->onlySections()->get();

        return (new FieldCollection($fields))->additional(['actions' => $this->actions]);
    }
}
