<?php

namespace EventPortal\Domain\Event\ViewModels;

use EventPortal\Concerns\Respondable;
use EventPortal\Domain\Component\Actions;
use EventPortal\Domain\Field\Models\Field;
use EventPortal\Domain\Field\Resources\SectionCollection;
use Spatie\ViewModels\ViewModel;

class EventEditViewModel extends ViewModel
{
    /** @var Respondable */
    public $model;

    /** @var Actions */
    private $actions;

    public function __construct(Respondable $model, ?Actions $actions)
    {
        $this->model = $model;
        $this->actions = optional($actions)->toArray();
    }

    public function form(): SectionCollection
    {
        $fields = Field::query()
            ->with(['children', 'children.response'])
            ->forModel($this->model)
            ->onlySections()
            ->get();

        return (new SectionCollection($fields))->additional(['actions' => $this->actions]);
    }
}
