<?php

namespace EventPortal\Domain\Field\Resources;

use Illuminate\Http\Resources\Json\JsonResource;

class SectionResource extends JsonResource
{
    /**
     * @phpcsSuppress SlevomatCodingStandard.TypeHints.ParameterTypeHint.MissingNativeTypeHint
     * @param \Illuminate\Http\Request $request
     * @return array
     */
    // phpcs:disable Generic.CodeAnalysis.UnusedFunctionParameter
    public function toArray($request): array
    {
    // phpcs:enable
        return [
            'id' => $this->id,
            'component' => $this->type,
            'name' => $this->name,
            'label' => $this->label,
            'children' => $this->when($this->isParent(), function () {
                return FieldResource::collection($this->children);
            }),
        ];
    }
}
