<?php

namespace EventPortal\Domain\Response\Models;

use EventPortal\Domain\Field\Models\Field;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\MorphMany;

abstract class RespondableModel extends Model
{
    public function fields(): MorphMany
    {
        return $this->morphMany(Field::class, 'respondable');
    }

    /** @return mixed **/
    public function getValueAttribute()
    {
        return $this->response->data->get('value');
    }

    public function getValidationRulesAttribute(): array
    {
        return $this
            ->fields()
            ->onlyChildren()
            ->get()
            ->mapWithKeys(function (Field $field): array {
                return [$field->name => $field->data->get('validation')];
            })
            ->filter()
            ->toArray();
    }
}
